// (c) Slavomir Tuleja, 5. november 2002
// Revised March 15, 2003
// JApplet sluzi na simulaciu orbitalneho pohybu druzice okolo Zeme

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.applet.*;
import javax.swing.*;
import javax.swing.event.*;


public class JOrbitLabOutline extends JApplet
   implements Runnable, ActionListener, MouseMotionListener, MouseListener{

   public BufferedImage image;
   //...komponenta - obrazok
   private ImageIcon iconPlay,iconStop,iconStepForward, iconStepBack,iconZoomIn,iconZoomOut;
   private MediaTracker tracker;
   private Image imPlay,imStop,imStepForward,imStepBack,imZoomIn,imZoomOut, imMap;

   private Graphics2D g2;
   //...objekt, ktory vie kreslit ciary, kruhy, ...
   private JButton btnStartStop, btnNastav, btnDopredu, btnDozadu, btnZoomIn, btnZoomOut, btnStav, btnReset;
   private JPanel pnlButtons,pnlLabels,pnlSouth;
   private JLabel lblTime, lblH, lblSirka, lblDlzka;
   private Platno platno;
   //...nas vlastny objekt sluziaci na zobrazenie image
   private TextualInputWindow windowNastavenia;
   private Container cp;
   //...kontainer - obsah okna appletu
   private Scale sc,scM;
   //...nas objekt pre transformaciu suradnic na pixely a opacne
   private Thread vlakno;
   //...podproces (vlakno) v ktorom pobezi animacia

   private OrbitODE ode=new Orbit();
   //...objekt diferencialnej rovnice kyvadla
   public ODEAdaptiveSolver odeAdaptiveSolver;
   //...objekt riesitela tejto dif. rovnice

   private PixelGrabber pg; //objekt umoznujuci pristup k pixelom
   private int[] pixelsM; //jednorozmerne pole s hodnotami pixelov
   private boolean[][] pixB;//dvojrozmerne pole pixelov zodpovedajuce mape a obsahujuce true ak pevnina, inak false
   private boolean[][] visited;// booleanske pole, ma hodnotu true ak bol pixel uz vybraty do nejakeho obrysu
   private Outline[] outline = new Outline[500];
   private int numOfOutlines=0;

   private double t,phi,theta,r;
   private double vR,vTheta,vPhi;
   private double rd,thetad,phid;
   public double phiInitial, thetaInitial, rInitial,vRInitial, vThetaInitial,vPhiInitial,dtInitial;
   public double dt;
   private final double Rz=6378e3;
   private double thetaStare,phiStare,rStare;
   private double xStare,yStare,zStare,x,y,z;
   private boolean koniec,dopad,cursorOver=false;
   private int w=450,h=450; //sirka a vyska image
   private int wM,hM;//sirka a vyska suboru gif s mapou ZEME
   private int ci, cj;//suradnice kurzora nad platnom
   private double thetaS;

   private double th;//definicie uhov pohladu
   private double ph;
   private double ph0,th0;
   private int mouseX,mouseY,mouseX0,mouseY0;
   private double konstanta=0.01;
   private int orbLength=1000;
   private Point3D[] orbit = new Point3D[orbLength];
   private ProjPoint[] orbProj = new ProjPoint[orbLength];
   private double zoom;
   public String parH, parFi, parLam, parVR, parVNorth, parVEast, parDT, parFiSun, parZoom, parThView, parPhView;


   public void init(){
      //toto je kvoli pocitadlu appletov:
      getImage(getCodeBase(), "obrazokA.php?nazov=JOrbitLabOutline&codeBase=" + getCodeBase());

      //nacitanie parametrov appletu
      parH = getParameter("h");
      parFi = getParameter("fi");
      parLam = getParameter("lam");
      parVR = getParameter("vNahor");
      parVNorth = getParameter("vSever");
      parVEast = getParameter("vVychod");
      parDT = getParameter("dt");
      parFiSun = getParameter("fiSlnko");
      parZoom = getParameter("zoom");
      parThView = getParameter("thetaPohladu");
      parPhView = getParameter("fiPohladu");

      //vytvorenie GUI
      cp=getContentPane();
      image=new BufferedImage(w,h,BufferedImage.TYPE_INT_RGB);
      platno=new Platno(image,this);
      //nacitanie gifu s mapou Zeme
      tracker = new MediaTracker(this);
      imPlay = getImage(getDocumentBase(), "Play.gif");
      tracker.addImage(imPlay,0);
      imStop = getImage(getDocumentBase(), "Stop.gif");
      tracker.addImage(imStop,1);
      imStepForward = getImage(getDocumentBase(), "StepForward.gif");
      tracker.addImage(imStepForward,2);
      imStepBack = getImage(getDocumentBase(), "StepBack.gif");
      tracker.addImage(imStepBack,3);
      imMap = getImage(getDocumentBase(), "map.gif");
      tracker.addImage(imMap,4);
      imZoomIn = getImage(getDocumentBase(), "ZoomIn.gif");
      tracker.addImage(imMap,5);
      imZoomOut = getImage(getDocumentBase(), "ZoomOut.gif");
      tracker.addImage(imMap,6);


      while(!tracker.checkAll(true))
         try
            {
                Thread.sleep(100);
            }
         catch(InterruptedException _ex) {
         }

      iconPlay = new ImageIcon(imPlay);
      iconStop = new ImageIcon(imStop);
      iconStepForward = new ImageIcon(imStepForward);
      iconStepBack = new ImageIcon(imStepBack);
      iconZoomIn = new ImageIcon(imZoomIn);
      iconZoomOut = new ImageIcon(imZoomOut);

      wM = imMap.getWidth(null);
      hM = imMap.getHeight(null);

      // Vytvorime nove dvojrozmerne pole integrov a do neho grabneme pomocou
      // objektu PixelGrabber hodnoty pixelov z imMap.
      // Musi sa pri tom pouzit try-catch ...
      pixelsM = new int[wM*hM];
      pg = new PixelGrabber(imMap, 0, 0, wM, hM, pixelsM, 0, wM);

      // nacitame do pola pixelsM pixely z obrazka
      try {
         pg.grabPixels();
      }
      catch (InterruptedException e) {
         System.err.println("Interrupted waiting for pixels!");
         return;
      }

      if ((pg.getStatus() & ImageObserver.ABORT) != 0) {
         System.err.println("Image fetch aborted or errored");
         return;
      }

      pixB = new boolean[wM][hM];
      visited = new boolean[wM][hM];
      for(int i=0;i<wM;i++){
         for(int j=0;j<hM;j++){
            if(pixelsM[wM*j+i]==-328147) pixB[i][j]=true;
            else pixB[i][j]=false;
            visited[i][j]=false;
         }
      }

      findOutlines();

      btnStartStop=new JButton("tart",iconPlay);
      btnNastav=new JButton("Nastavenia");
      btnDopredu = new JButton("Krok",iconStepForward);
      btnDozadu = new JButton("Krok",iconStepBack);
      btnZoomIn = new JButton("Zvi",iconZoomIn);
      btnZoomOut = new JButton("Zmeni",iconZoomOut);
      btnReset = new JButton("Reset");
      btnStav = new JButton("Stav druice");

      lblTime= new JLabel("t = 0 s");
      lblH=new JLabel("h = ".concat(MyUtils.roundOff(Double.valueOf(parH).doubleValue()/1000.0,1)).concat(" km"));
      lblSirka=new JLabel("z..: ");
      lblDlzka=new JLabel("z.d.: ");

      pnlButtons=new JPanel();
      pnlButtons.setLayout(new GridLayout(2,4));
      pnlButtons.add(btnStartStop);
      pnlButtons.add(btnDozadu);
      pnlButtons.add(btnDopredu);
      pnlButtons.add(btnReset);
      pnlButtons.add(btnZoomIn);
      pnlButtons.add(btnZoomOut);
      pnlButtons.add(btnStav);
      pnlButtons.add(btnNastav);

      pnlLabels = new JPanel();
      pnlLabels.setLayout(new GridLayout(1,4));
      pnlLabels.add(lblTime);
      pnlLabels.add(lblH);
      pnlLabels.add(lblSirka);
      pnlLabels.add(lblDlzka);

      pnlSouth = new JPanel();
      pnlSouth.setLayout(new BoxLayout(pnlSouth,BoxLayout.Y_AXIS));
      pnlSouth.add(pnlLabels);
      pnlSouth.add(pnlButtons);

      cp.setLayout(new BorderLayout());
      cp.add(platno,BorderLayout.CENTER);
      cp.add(pnlSouth,BorderLayout.SOUTH);

      btnStartStop.addActionListener(this);
      btnDopredu.addActionListener(new StepForwardHandler(this));
      btnDozadu.addActionListener(new StepBackHandler(this));
      btnNastav.addActionListener(this);
      btnZoomIn.addActionListener(this);
      btnZoomOut.addActionListener(this);
      btnReset.addActionListener(this);
      btnStav.addActionListener(this);

      g2=image.createGraphics();

      //platno.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
      platno.addMouseMotionListener(this);
      platno.addMouseListener(this);


      windowNastavenia = new TextualInputWindow(this);

      rInitial=Double.valueOf(parH).doubleValue()+Rz;
      thetaInitial=90-Double.valueOf(parFi).doubleValue();
      phiInitial=toDlzka(Double.valueOf(parLam).doubleValue()/180.0*Math.PI);
      vRInitial=Double.valueOf(parVR).doubleValue();
      vThetaInitial=-Double.valueOf(parVNorth).doubleValue();
      vPhiInitial=Double.valueOf(parVEast).doubleValue();
      dtInitial=Double.valueOf(parDT).doubleValue();
      thetaS=Math.PI/2.0-Double.valueOf(parFiSun).doubleValue()/180.0*Math.PI;
      zoom=Double.valueOf(parZoom).doubleValue();
      th=Double.valueOf(parThView).doubleValue()/180.0*Math.PI;
      ph=Double.valueOf(parPhView).doubleValue()/180.0*Math.PI;

      setScales();
      reset();
      nastavSimulaciu(rInitial,thetaInitial,phiInitial,vRInitial,vThetaInitial,vPhiInitial,0,dtInitial);


   }

   public void reset(){
      nastavSimulaciu(rInitial,thetaInitial,phiInitial,vRInitial,vThetaInitial,vPhiInitial,0,dtInitial);
   }

   public void nastavSimulaciu(double r, double theta, double phi, double vR, double vTheta, double vPhi, double t, double dt) {
      //vstupne uhly su v STUPNOCH!!!
      koniec=false;
      dopad=false;
      this.t=t;
      this.r=r;
      this.theta=theta/180.0*Math.PI;
      this.phi=phi/180.0*Math.PI;
      this.dt=dt;

      //tu sa nastavia zaciatocne podmienky InitialConditions
      ode.setIC(r,theta/180.0*Math.PI,phi/180.0*Math.PI,vR,vTheta,vPhi);

      lblTime.setText("t = ".concat(MyUtils.roundOff(t,0)).concat(" s"));
      lblH.setText("h = ".concat(MyUtils.roundOff((r-Rz)/1000.0,1)).concat(" km"));
      lblSirka.setText("z..: ".concat(MyUtils.roundOff(toSirka(this.theta),1)).concat(" "));
      lblDlzka.setText("z.d.: ".concat(MyUtils.roundOff(toDlzka(this.phi),1)).concat(" "));

      //inicializacia ODESolvera
      odeAdaptiveSolver=new RK45MultiStep(ode);
      odeAdaptiveSolver.initialize(dt);
      odeAdaptiveSolver.setTolerance(1e-6);
      //...tolerancia pri jednom kroku
      odeAdaptiveSolver.setStepSize(dt);
      //...dlzka fixneho kroku

      //vynulovanie pola orbitalnej drahy
      for(int i=0;i<orbLength;i++){
         orbit[i]=new Point3D(ode.getX()/Rz,ode.getY()/Rz,ode.getZ()/Rz);
         orbProj[i]=new ProjPoint(ode.getPhi(),ode.getTheta());
      }

      kresliSpodok(g2);
      platno.repaint();
   }


   public void actionPerformed(ActionEvent e){
      if(e.getActionCommand().equals("Stop")){
         //po stisnuti STOP
         koniec=true;
         btnStartStop.setText("tart");
         btnStartStop.setIcon(iconPlay);
         btnDopredu.setEnabled(true);
         btnDozadu.setEnabled(true);
         btnNastav.setEnabled(true);
         btnReset.setEnabled(true);
         btnStav.setEnabled(true);
      }
      else if(e.getActionCommand().equals("tart")&&(!dopad)){
         //po stisnuti START
         koniec=false;
         btnStartStop.setText("Stop");
         btnStartStop.setIcon(iconStop);
         btnDopredu.setEnabled(false);
         btnDozadu.setEnabled(false);
         btnNastav.setEnabled(false);
         btnReset.setEnabled(false);
         btnStav.setEnabled(false);
         vlakno=new Thread(this);
         vlakno.start();
      }

      else if(e.getActionCommand().equals("Krok")){
      }
      else if(e.getActionCommand().equals("Reset")){
         reset();
         repaint();
      }
      else if(e.getActionCommand().equals("Stav druice")){
         vypisStav();
      }
      else if(e.getActionCommand().equals("Nastavenia")){
         //po stisnuti NASTAVENIA
         windowNastavenia.setLocation();
         windowNastavenia.show();
      }
      else if(e.getActionCommand().equals("Zvi")){
         zoom/=1.25;
         if(zoom<=0.8) {
            zoom=0.8;
            btnZoomIn.setEnabled(false);
         }
         setScales();
      }
      else if(e.getActionCommand().equals("Zmeni")){
         btnZoomIn.setEnabled(true);
         zoom*=1.25;
         setScales();
      }
   }

   public void vypisStav(){
      String s;
      s=new String("Stav druice:\n");
      s=s.concat("Vka:  ").concat(MyUtils.roundOff(ode.getR()-Rz,0)).concat(" m\n");
      s=s.concat("Zem. rka:  ").concat(MyUtils.roundOff(toSirka(ode.getTheta()),1)).concat(" \u00b0 \n");
      s=s.concat("Zem. dka:  ").concat(MyUtils.roundOff(toDlzka(ode.getPhi()),1)).concat(" \u00b0 \n");
      s=s.concat("Rchlos nahor:  ").concat(MyUtils.roundOff(ode.getVR(),1)).concat(" m/s \n");
      s=s.concat("Rchlos na sever:  ").concat(MyUtils.roundOff(-ode.getVTheta(),1)).concat(" m/s \n");
      s=s.concat("Rchlos na vchod:  ").concat(MyUtils.roundOff(ode.getVPhi(),1)).concat(" m/s \n");
      s=s.concat("Vekos rchlosti:  ").concat(MyUtils.roundOff(Math.sqrt(ode.getVR()*ode.getVR()+ode.getVPhi()*ode.getVPhi()+ode.getVTheta()*ode.getVTheta()),1)).concat(" m/s \n");

      JOptionPane.showMessageDialog(this,s,"Aktulny stav druice",JOptionPane.INFORMATION_MESSAGE);
   }

   private void findOutlines(){
      int i;
      int j;
      numOfOutlines=0;
      for(i=0;i<wM;i++){
         for(j=1;j<hM-1;j++){
            if((!visited[i][j])&&(isOnEdge(new IntegerPoint(i,j)))){
               outline[numOfOutlines] = new Outline();
               hladajOutline(outline[numOfOutlines],i,j);
               numOfOutlines++;
            }
         }
      }
   }

   private boolean isOnEdge(IntegerPoint p){
      int i=p.getI();
      int j=p.getJ();
      boolean b=(!pixB[getIMinus(i)][j-1])|(!pixB[getIMinus(i)][j])|(!pixB[getIMinus(i)][j+1])|(!pixB[i][j-1])|(!pixB[i][j+1])|(!pixB[getIPlus(i)][j-1])|(!pixB[getIPlus(i)][j])|(!pixB[getIPlus(i)][j+1]);
      //boolean b=(!pixB[getIMinus(i)][j])|(!pixB[i][j-1])|(!pixB[i][j+1])|(!pixB[getIPlus(i)][j]);
      b&=pixB[i][j];
      return b;
   }

   /**
    * Funkcia zabezpecuje to, ze nevybehneme z pola pixB. Suvisi s tym, ze mapa zeme je cyklicka v x-ovom smere
    */
   private int getIPlus(int i){
      if((i+1)<wM) return i+1;
      else return 0;
   }

   private int getIMinus(int i){
      if((i-1)>=0) return i-1;
      else return wM-1;
   }

   /**
    * K danemu pixelu [i,j] najde outline, ktory z neho vychadza
    */
   private void hladajOutline(Outline outline, int i, int j){
      visited[i][j]=true;
      outline.addPoint(new IntegerPoint(i,j));
      if((!visited[i][j+1])&&(isOnEdge(new IntegerPoint(i,j+1)))) hladajOutline(outline,i,j+1);
      if((!visited[i][j-1])&&(isOnEdge(new IntegerPoint(i,j-1)))) hladajOutline(outline,i,j-1);
      if((!visited[getIPlus(i)][j-1])&&(isOnEdge(new IntegerPoint(getIPlus(i),j-1)))) hladajOutline(outline,getIPlus(i),j-1);
      if((!visited[getIPlus(i)][j])&&(isOnEdge(new IntegerPoint(getIPlus(i),j)))) hladajOutline(outline,getIPlus(i),j);
      if((!visited[getIPlus(i)][j+1])&&(isOnEdge(new IntegerPoint(getIPlus(i),j+1)))) hladajOutline(outline,getIPlus(i),j+1);
      if((!visited[getIMinus(i)][j-1])&&(isOnEdge(new IntegerPoint(getIMinus(i),j-1)))) hladajOutline(outline,getIMinus(i),j-1);
      if((!visited[getIMinus(i)][j])&&(isOnEdge(new IntegerPoint(getIMinus(i),j)))) hladajOutline(outline,getIMinus(i),j);
      if((!visited[getIMinus(i)][j+1])&&(isOnEdge(new IntegerPoint(getIMinus(i),j+1)))) hladajOutline(outline,getIMinus(i),j+1);
   }

   public void kresliOutlines(Graphics2D g2){
      int i1,j1,i2,j2;
      double x1,x2,y1,y2,z1,z2,sx,sy,sz,scs;
      double ph1,ph2,th1,th2;
      int iP1,jP1,iP2,jP2;
      g2.setColor(Color.blue);
      g2.fillOval(sc.xToi(-1),sc.yToj(1),sc.xToi(1)-sc.xToi(-1),sc.yToj(-1)-sc.yToj(1));
      g2.setColor(Color.green);
      for(int n=0; n<numOfOutlines;n++){
         for(int k=0; k<outline[n].n-1;k++){
            i1=outline[n].getPoint(k).getI();
            j1=outline[n].getPoint(k).getJ();
            i2=outline[n].getPoint(k+1).getI();
            j2=outline[n].getPoint(k+1).getJ();
            ph1=adjust(scM.iTox(i1));//rotacia zeme
            th1=scM.jToy(j1);
            ph2=adjust(scM.iTox(i2));
            th2=scM.jToy(j2);
            x1=Math.cos(ph1)*Math.sin(th1);
            y1=Math.sin(ph1)*Math.sin(th1);
            z1=Math.cos(th1);
            x2=Math.cos(ph2)*Math.sin(th2);
            y2=Math.sin(ph2)*Math.sin(th2);
            z2=Math.cos(th2);
            sx=0.5*(x2+x1);
            sy=0.5*(y2+y1);
            sz=0.5*(z2+z1);
            scs=sx*Math.cos(ph)*Math.sin(th)+sy*Math.sin(ph)*Math.sin(th)+sz*Math.cos(th);
            iP1=sc.xToi(getXP(x1,y1,z1));
            jP1=sc.yToj(getYP(x1,y1,z1));
            iP2=sc.xToi(getXP(x2,y2,z2));
            jP2=sc.yToj(getYP(x2,y2,z2));

            if((Math.abs(i1-i2)<3)&&(Math.abs(j1-j2)<3)&&(scs>0)) g2.drawLine(iP1,jP1,iP2,jP2);
         }
      }
   }

   public void kresliVrch(Graphics2D g2){
      kresliOutlines(g2);
      kresliTien(g2);
      kresliOblastViditelnosti(g2);
      kresliDruzicu(g2);
   }

   private void kresliDruzicu(Graphics2D g2){
      double x1,y1,z1,x2,y2,z2,xP1,yP1,xP2,yP2,xPs,yPs,xs,ys,zs;
      double scs,dis;
      double ph1,ph2,th1,th2;

      //kreslenie priemetu trajektorie
      g2.setColor(Color.yellow);
      for(int i=0;i<orbLength-1;i++){
         ph1=adjust(orbProj[i].getPhi());th1=orbProj[i].getTheta();
         ph2=adjust(orbProj[i+1].getPhi());th2=orbProj[i+1].getTheta();
         x1=Math.cos(ph1)*Math.sin(th1);y1=Math.sin(ph1)*Math.sin(th1);z1=Math.cos(th1);
         x2=Math.cos(ph2)*Math.sin(th2);y2=Math.sin(ph2)*Math.sin(th2);z2=Math.cos(th2);

         xP1=getXP(x1,y1,z1);
         yP1=getYP(x1,y1,z1);
         xP2=getXP(x2,y2,z2);
         yP2=getYP(x2,y2,z2);
         xPs=0.5*(xP1+xP2);
         yPs=0.5*(yP1+yP2);
         xs=0.5*(x1+x2);
         ys=0.5*(y1+y2);
         zs=0.5*(z1+z2);
         dis=Math.sqrt(xPs*xPs+yPs*yPs);
         scs=Math.cos(ph)*Math.sin(th)*xs+Math.sin(ph)*Math.sin(th)*ys+Math.cos(th)*zs;
         if(!(dis<1)||!(scs<0)) {
            g2.drawLine(sc.xToi(xP1),sc.yToj(yP1),sc.xToi(xP2),sc.yToj(yP2));
         }
      }
      g2.setColor(Color.red);
      //kreslenie trajektorie
      for(int i=0;i<orbLength-1;i++){
         x1=orbit[i].getX();y1=orbit[i].getY();z1=orbit[i].getZ();
         x2=orbit[i+1].getX();y2=orbit[i+1].getY();z2=orbit[i+1].getZ();

         xP1=getXP(x1,y1,z1);
         yP1=getYP(x1,y1,z1);
         xP2=getXP(x2,y2,z2);
         yP2=getYP(x2,y2,z2);
         xPs=0.5*(xP1+xP2);
         yPs=0.5*(yP1+yP2);
         xs=0.5*(x1+x2);
         ys=0.5*(y1+y2);
         zs=0.5*(z1+z2);
         dis=Math.sqrt(xPs*xPs+yPs*yPs);
         scs=Math.cos(ph)*Math.sin(th)*xs+Math.sin(ph)*Math.sin(th)*ys+Math.cos(th)*zs;
         if(!(dis<1)||!(scs<0)) {
            g2.drawLine(sc.xToi(xP1),sc.yToj(yP1),sc.xToi(xP2),sc.yToj(yP2));
            if(i==orbLength-2) {
               g2.setColor(Color.red);
               g2.fillOval(sc.xToi(getXP(ode.getX()/Rz,ode.getY()/Rz,ode.getZ()/Rz))-3, sc.yToj(getYP(ode.getX()/Rz,ode.getY()/Rz,ode.getZ()/Rz))-3,6,6);
               g2.setColor(Color.black);
               g2.drawOval(sc.xToi(getXP(ode.getX()/Rz,ode.getY()/Rz,ode.getZ()/Rz))-3, sc.yToj(getYP(ode.getX()/Rz,ode.getY()/Rz,ode.getZ()/Rz))-3,6,6);
            }
         }
      }


      //ramik okolo image
      g2.setColor(Color.black);
      g2.drawLine(0,0,w-1,0);
      g2.drawLine(w-1,0,w-1,h-1);
      g2.drawLine(w-1,h-1,0,h-1);
      g2.drawLine(0,h-1,0,0);
      repaint();
   }

   private void kresliTien(Graphics2D g2){
      double nSx,nSy,nSz; //vektor od stredu Zeme k Slnku
      double px,py,rs,tt,x,y,z;
      double phiS=0;
      while(phiS>Math.PI)phiS-=2*Math.PI;
      while(phiS<-Math.PI)phiS+=2*Math.PI;
      int di=2,dj=2;
      nSx=Math.sin(thetaS)*Math.cos(phiS);
      nSy=Math.sin(thetaS)*Math.sin(phiS);
      nSz=Math.cos(thetaS);
      //kreslenie tiena
      for(int j=0;j<h;j+=2*dj){
         for(int i=0; i<w-di; i+=di){
            px=sc.iTox(i);
            py=sc.jToy(j);
            rs=1-px*px-py*py;
            if(rs>=0){
               tt=Math.sqrt(rs);
               x=-px*Math.sin(ph)-py*Math.cos(ph)*Math.cos(th)+tt*Math.cos(ph)*Math.sin(th);
               y=px*Math.cos(ph)-py*Math.sin(ph)*Math.cos(th)+tt*Math.sin(ph)*Math.sin(th);
               z=py*Math.sin(th)+tt*Math.cos(th);

               if(x*nSx+y*nSy+z*nSz<0){
                  g2.setColor(Color.black);
                  g2.drawLine(i,j,i,j);
               }

               px=sc.iTox(i+di/2);
               py=sc.jToy(j+dj);
               rs=1-px*px-py*py;
               if(rs>=0){
                  tt=Math.sqrt(rs);
                  x=-px*Math.sin(ph)-py*Math.cos(ph)*Math.cos(th)+tt*Math.cos(ph)*Math.sin(th);
                  y=px*Math.cos(ph)-py*Math.sin(ph)*Math.cos(th)+tt*Math.sin(ph)*Math.sin(th);
                  z=py*Math.sin(th)+tt*Math.cos(th);

                  if(x*nSx+y*nSy+z*nSz<0){
                     g2.setColor(Color.black);
                     g2.drawLine(i+di/2,j+dj,i+di/2,j+dj);
                  }
               }
            }
         }
      }
   }

   private void kresliOblastViditelnosti(Graphics2D g2){
      double thetaP,alphaP;//suradnice bodu na obvode kruznice viditelnosti
      double thetaPStare, alphaPStare;
      double rho=Math.acos(Rz/ode.getR());//uhlovy polomer kruznice viditelnosti
      double beta=0, dBeta=Math.PI/90.0;
      double ph1,ph2,th1,th2,ph3,ph4,th3,th4;
      int i1,i2,j1,j2,i3,i4,j3,j4;
      double x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4;
      double nx,ny,nz;

      nx=Math.sin(th)*Math.cos(ph);
      ny=Math.sin(th)*Math.sin(ph);
      nz=Math.cos(th);

      g2.setColor(Color.white);

      thetaPStare=Math.acos(Math.cos(ode.getTheta())*Math.cos(rho)+Math.sin(ode.getTheta())*Math.sin(rho)*Math.cos(beta));
      alphaPStare=Math.asin(Math.sin(beta)*Math.sin(rho)/Math.sin(thetaPStare));
      if(Math.cos(rho)-Math.cos(thetaPStare)*Math.cos(ode.getTheta())<0) alphaPStare=Math.PI-alphaPStare;

      while(beta<Math.PI){
         beta+=dBeta;

         thetaP=Math.acos(Math.cos(ode.getTheta())*Math.cos(rho)+Math.sin(ode.getTheta())*Math.sin(rho)*Math.cos(beta));
         alphaP=Math.asin(Math.sin(beta)*Math.sin(rho)/Math.sin(thetaP));
         if(Math.cos(rho)-Math.cos(thetaP)*Math.cos(ode.getTheta())<0) alphaP=Math.PI-alphaP;

         ph1=ode.getPhi()-alphaPStare;
         ph2=ode.getPhi()-alphaP;
         th1=thetaPStare;
         th2=thetaP;
         ph3=ode.getPhi()+alphaPStare;
         ph4=ode.getPhi()+alphaP;
         th3=thetaPStare;
         th4=thetaP;

         x1=Math.cos(ph1)*Math.sin(th1);
         y1=Math.sin(ph1)*Math.sin(th1);
         z1=Math.cos(th1);
         x2=Math.cos(ph2)*Math.sin(th2);
         y2=Math.sin(ph2)*Math.sin(th2);
         z2=Math.cos(th2);
         x3=Math.cos(ph3)*Math.sin(th3);
         y3=Math.sin(ph3)*Math.sin(th3);
         z3=Math.cos(th3);
         x4=Math.cos(ph4)*Math.sin(th4);
         y4=Math.sin(ph4)*Math.sin(th4);
         z4=Math.cos(th4);

         i1=sc.xToi(getXP(x1,y1,z1));
         j1=sc.yToj(getYP(x1,y1,z1));
         i2=sc.xToi(getXP(x2,y2,z2));
         j2=sc.yToj(getYP(x2,y2,z2));
         i3=sc.xToi(getXP(x3,y3,z3));
         j3=sc.yToj(getYP(x3,y3,z3));
         i4=sc.xToi(getXP(x4,y4,z4));
         j4=sc.yToj(getYP(x4,y4,z4));

         if(0.5*(x1+x2)*nx+0.5*(y1+y2)*ny+0.5*(z1+z2)*nz>0) g2.drawLine(i1,j1,i2,j2);
         if(0.5*(x3+x4)*nx+0.5*(y3+y4)*ny+0.5*(z3+z4)*nz>0) g2.drawLine(i3,j3,i4,j4);


         thetaPStare=thetaP;
         alphaPStare=alphaP;
      }
   }

   public double adjust(double phi){
      //najprv upravi phi vzhladom na rotaciu Zeme a potom
      //ho upravi tak, aby lezal v intervale od -PI do PI
      double phiA=phi+7.272e-5*t;
      while(phiA>Math.PI) phiA-=2*Math.PI;
      while(phiA<-Math.PI) phiA+=2*Math.PI;
      return phiA;
   }

   public void kresliSpodok(Graphics2D g2){
      g2.setColor(Color.black);
      g2.fillRect(0,0,w,h);
      g2.setColor(Color.black);
      g2.drawRect(0,0,w-1,h-1);
   }

   /**
    * Nastavi objekty Scale pre oba image, konkretne pre mapu Zeme a pre 3D obrazok.
    */
   public void setScales(){
      sc= new Scale(-1.05*zoom,1.05*zoom,-1.05*zoom,1.05*zoom,0,w-1,0,h-1);
      scM= new Scale(-Math.PI,Math.PI,Math.PI,0,0,wM-1,0,hM-1);
   }

   /**
    * Vrati x-ovu suradnicu priemetu bodu do roviny kolmej k vektoru pohladu
    */
   public double getXP(double x, double y, double z){
      return -x*Math.sin(ph)+y*Math.cos(ph);
   }

   /**
    * Vrati y-ovu suradnicu priemetu bodu do roviny kolmej k vektoru pohladu
    */
   public double getYP(double x, double y, double z){
      return -x*Math.cos(ph)*Math.cos(th)-y*Math.sin(ph)*Math.cos(th)+z*Math.sin(th);
   }

   public void run(){
      while (!koniec && !dopad){
         simulationStep();
         try {
            vlakno.sleep(100);
         }
         catch(InterruptedException exception){
            System.err.println("Interrupted...");
         }
      }
   }

   public void simulationStep(){
      phiStare=ode.getPhi();
      thetaStare=ode.getTheta();
      rStare=ode.getR();
      for(int i=0;i<orbLength-1;i++){
         orbit[i]=orbit[i+1];
         orbProj[i]=orbProj[i+1];
      }
      t+=odeAdaptiveSolver.step();
      //...vykonava sa krok Runge Kutteho metody

      orbit[orbLength-1]=new Point3D(ode.getX()/Rz,ode.getY()/Rz,ode.getZ()/Rz);
      orbProj[orbLength-1]=new ProjPoint(ode.getPhi()-7.272e-5*t,ode.getTheta());
      phi=ode.getPhi();
      theta=ode.getTheta();
      r=ode.getR();

      lblTime.setText("t = ".concat(MyUtils.roundOff(t,0)).concat(" s"));
      lblH.setText("h = ".concat(MyUtils.roundOff((r-Rz)/1000.0,1)).concat(" km"));
      lblSirka.setText("z..: ".concat(MyUtils.roundOff(toSirka(theta),1)).concat(" "));
      lblDlzka.setText("z.d.: ".concat(MyUtils.roundOff(toDlzka(phi-7.272e-5*t),1)).concat(" "));

      if(r<Rz){//osetrenie dopadu na zem
         koniec=true;
         dopad=true;
         btnStartStop.setText("tart");
         btnStartStop.setIcon(iconPlay);
         btnDopredu.setEnabled(true);
         btnDozadu.setEnabled(true);
         btnNastav.setEnabled(true);
         btnReset.setEnabled(true);
         btnStav.setEnabled(true);
      }
      if(dopad)JOptionPane.showMessageDialog(this,"Je mi to, ale druica spadla na Zem...","Upozornenie",JOptionPane.WARNING_MESSAGE);
   }

   private double toSirka(double theta){
      //vstup uhol theta v radianoch
      //vrzti zem. sirku v stupnoch
      double th=theta/Math.PI*180.0;
      return 90-th;
   }

   private double toDlzka(double phi){
      //vstup uhol phi v radianoch
      //vystup zem. dlzka v stupnoch
      double ph=phi/Math.PI*180.0;
      while(ph>180)ph=ph-360;
      while(ph<-180)ph=ph+360;
      return ph;
   }

   public void mousePressed(MouseEvent e){
      //zapamata si polohu pixela kde zacal dragging
      th0=th;
      ph0=ph;
      mouseX0=e.getX();
      mouseY0=e.getY();
   }

   public void mouseDragged(MouseEvent e){
      //sluzi na zmenu smeru pohladu na kuzel
      mouseX=e.getX();
      mouseY=e.getY();
      ph=ph0-konstanta*(mouseX-mouseX0);
      ph=upravPh(ph);
      th=th0-konstanta*(mouseY-mouseY0);
      if (th<0){th=0;}
      if (th>Math.PI){th=Math.PI;}
      platno.repaint();
   }


   public void mouseReleased(MouseEvent e){

   }

   public void mouseEntered(MouseEvent e){
      cursorOver=true;
      platno.repaint();
   }

   public void mouseExited(MouseEvent e){
      cursorOver=false;
      platno.repaint();
   }

   public void mouseClicked(MouseEvent e){
      //zoom=zoom/1.25;
      //setScales();
   }

   public void mouseMoved(MouseEvent e){
   }

   public double upravPh(double ph){
      //upravi hodnotu uhla fi v radianoch do intervalu <0,2PI>
      if (ph>2*Math.PI){
         while (ph>2*Math.PI){
            ph=ph-2*Math.PI;
         }
      }
      else
      if (ph<0) {
         while (ph<0){
            ph=ph+2*Math.PI;
         }
      }
      return ph;
   }
}

class TextualInputWindow extends JDialog implements ActionListener {
   JOrbitLabOutline applet;
   JLabel lblH, lblLatitude, lblLongitude, lblVR, lblVNorth, lblVEast, lblDT;
   JTextField tfH, tfLatitude, tfLongitude, tfVR, tfVNorth, tfVEast, tfDT;
   JPanel pnlCenter, pnlButtons;
   JButton btnOK, btnCancel;
   String sH,sTheta,sPhi,sVR,sVTheta,sVPhi,sDT;

   //constructor
   public TextualInputWindow(JOrbitLabOutline applet){
      setModal(true);
      setTitle("Nastavenia simulcie");
      setSize(200,320);
      setResizable(false);

      this.applet=applet;

      Container cp=getContentPane();
      btnOK=new JButton("OK");
      btnCancel=new JButton("Cancel");
      lblH = new JLabel("h / m:");
      lblLatitude = new JLabel("zemepisn rka / stupne:");
      lblLongitude = new JLabel("zemepisn dka / stupne:");
      lblVR = new JLabel("rchlos nahor / m/s:");
      lblVNorth = new JLabel("rchlos na sever / m/s:");
      lblVEast = new JLabel("rchlos na vchod / m/s:");
      lblDT = new JLabel("asov krok / m/s:");
      tfH= new JTextField(applet.parH);
      tfLatitude= new JTextField(applet.parFi);
      tfLongitude= new JTextField(applet.parLam);
      tfVR= new JTextField(applet.parVR);
      tfVNorth= new JTextField(applet.parVNorth);
      tfVEast= new JTextField(applet.parVEast);
      tfDT = new JTextField(applet.parDT);

      pnlCenter=new JPanel();
      pnlCenter.setLayout(new BoxLayout(pnlCenter,BoxLayout.Y_AXIS));
      pnlCenter.add(lblH);
      pnlCenter.add(tfH);
      pnlCenter.add(lblLatitude);
      pnlCenter.add(tfLatitude);
      pnlCenter.add(lblLongitude);
      pnlCenter.add(tfLongitude);
      pnlCenter.add(lblVR);
      pnlCenter.add(tfVR);
      pnlCenter.add(lblVNorth);
      pnlCenter.add(tfVNorth);
      pnlCenter.add(lblVEast);
      pnlCenter.add(tfVEast);
      pnlCenter.add(lblDT);
      pnlCenter.add(tfDT);

      pnlCenter.setAlignmentX(Component.LEFT_ALIGNMENT);
      pnlCenter.setPreferredSize(new Dimension(150,350));

      pnlCenter.add(Box.createVerticalGlue());
      pnlCenter.setBorder(BorderFactory.createEmptyBorder(0, 5, 0, 5));

      pnlButtons = new JPanel();
      pnlButtons.setLayout(new GridLayout(1,2));
      pnlButtons.add(btnOK);
      pnlButtons.add(btnCancel);
      pnlButtons.setBorder(BorderFactory.createEmptyBorder(0, 5, 0, 5));

      cp.add(pnlButtons,BorderLayout.SOUTH);
      cp.add(pnlCenter,BorderLayout.CENTER);

      btnOK.addActionListener(this);
      btnCancel.addActionListener(this);
      //nacitanie starych hodnot
      sH=tfH.getText();
      sTheta=tfLatitude.getText();
      sPhi=tfLongitude.getText();
      sVR=tfVR.getText();
      sVTheta=tfVNorth.getText();
      sVPhi=tfVEast.getText();
      sDT=tfDT.getText();
   }


   public void setLocation(){
      //Sets the location of Textual Input Window so that it is
      //centered at the applet...
      Point cpP=applet.getContentPane().getLocationOnScreen();
      int ic=Math.round((float)cpP.getX());
      int jc=Math.round((float)cpP.getY());
      setLocation(new Point(ic+125,jc+75));
   }

   public void actionPerformed(ActionEvent e){
      double r,theta,phi,vR,vTheta,vPhi,dt;//uhly v stupnoch!!!
      boolean vsetkoOK;
      if(e.getActionCommand().equals("OK")){
         //after pressing OK button...
         vsetkoOK=true;
         try {
            r=Double.valueOf(tfH.getText()).doubleValue()+6378e3;
            sH=tfH.getText();
            applet.rInitial=r;
         }
         catch(NumberFormatException ex){
            JOptionPane.showMessageDialog(this,"Nesprvny formt vstupnej hodnoty!\nSkste to znovu.","Chyba vstupu",JOptionPane.ERROR_MESSAGE);
            tfH.setText(sH);
            r=Double.valueOf(sH).doubleValue()+6378e3;
            vsetkoOK=false;
         }
         try {
            theta=90-Double.valueOf(tfLatitude.getText()).doubleValue();
            sTheta=tfLatitude.getText();
            applet.thetaInitial=theta;
         }
         catch(NumberFormatException ex){
            JOptionPane.showMessageDialog(this,"Nesprvny formt vstupnej hodnoty!\nSkste to znovu.","Chyba vstupu",JOptionPane.ERROR_MESSAGE);
            tfLatitude.setText(sTheta);
            theta=90-Double.valueOf(sTheta).doubleValue();
            vsetkoOK=false;
         }
         try {
            phi=Double.valueOf(tfLongitude.getText()).doubleValue();
            if(phi<0)phi=phi+360;
            sPhi=tfLongitude.getText();
            applet.phiInitial=phi;
         }
         catch(NumberFormatException ex){
            JOptionPane.showMessageDialog(this,"Nesprvny formt vstupnej hodnoty!\nSkste to znovu.","Chyba vstupu",JOptionPane.ERROR_MESSAGE);
            tfLongitude.setText(sPhi);
            phi=Double.valueOf(sPhi).doubleValue();
            if(phi<0)phi=phi+360;
            vsetkoOK=false;
         }
         try {
            vR=Double.valueOf(tfVR.getText()).doubleValue();
            sVR=tfVR.getText();
            applet.vRInitial=vR;
         }
         catch(NumberFormatException ex){
            JOptionPane.showMessageDialog(this,"Nesprvny formt vstupnej hodnoty!\nSkste to znovu.","Chyba vstupu",JOptionPane.ERROR_MESSAGE);
            tfVR.setText(sVR);
            vR=Double.valueOf(sVR).doubleValue();
            vsetkoOK=false;
         }
         try {
            vTheta=-Double.valueOf(tfVNorth.getText()).doubleValue();
            sVTheta=tfVNorth.getText();
            applet.vThetaInitial=vTheta;
         }
         catch(NumberFormatException ex){
            JOptionPane.showMessageDialog(this,"Nesprvny formt vstupnej hodnoty!\nSkste to znovu.","Chyba vstupu",JOptionPane.ERROR_MESSAGE);
            tfVNorth.setText(sVTheta);
            vTheta=-Double.valueOf(sVTheta).doubleValue();
            vsetkoOK=false;
         }
         try {
            vPhi=Double.valueOf(tfVEast.getText()).doubleValue();
            sVPhi=tfVEast.getText();
            applet.vPhiInitial=vPhi;
         }
         catch(NumberFormatException ex){
            JOptionPane.showMessageDialog(this,"Nesprvny formt vstupnej hodnoty!\nSkste to znovu.","Chyba vstupu",JOptionPane.ERROR_MESSAGE);
            tfVEast.setText(sVPhi);
            vPhi=Double.valueOf(sVPhi).doubleValue();
            vsetkoOK=false;
         }
         try {
            dt=Double.valueOf(tfDT.getText()).doubleValue();
            sDT=tfDT.getText();
            applet.dt=dt;
            applet.dtInitial=dt;
         }
         catch(NumberFormatException ex){
            JOptionPane.showMessageDialog(this,"Nesprvny formt vstupnej hodnoty!\nSkste to znovu.","Chyba vstupu",JOptionPane.ERROR_MESSAGE);
            tfDT.setText(sDT);
            dt=Double.valueOf(sDT).doubleValue();
            vsetkoOK=false;
         }
         //este overime, ci theta je v intervale od 0 do 180 a ci r je kladne
         while(theta>180)theta-=360;
         while(theta<-180)theta+=360;
         //tym sme dostali theta do intervalu (-180,180)
         if(theta<0){
            theta=-theta;
            phi=phi+180;
            vsetkoOK=false;
         }
         while(phi>360){
            phi-=360;
            vsetkoOK=false;
         }
         while(phi<0){
            phi+=360;
            vsetkoOK=false;
         }
         if(!vsetkoOK){
            double phiPom=phi;
            if(phiPom>180)phiPom=phi-360;
            tfLongitude.setText(MyUtils.roundOff(phiPom,4));
            tfLatitude.setText(MyUtils.roundOff(90-theta,4));
         }
         //tym sme phi dostali do intervalu (0,360)
         if(r-6378e3<0){
            r=6378e3;
            tfH.setText(MyUtils.roundOff(0,0));
            vsetkoOK=false;
         }

         if(vsetkoOK){
            applet.nastavSimulaciu(r,theta,phi,vR,vTheta,vPhi,0,dt);
            hide();
            applet.repaint();
         }
      }
      else {
         //after pressing Cancel button...
         tfH.setText(sH);
         tfLatitude.setText(sTheta);
         tfLongitude.setText(sPhi);
         tfVR.setText(sVR);
         tfVNorth.setText(sVTheta);
         tfVEast.setText(sVPhi);

         hide();
         applet.repaint();
      }
   }

}

class StepForwardHandler implements ActionListener {
   JOrbitLabOutline applet;

   public StepForwardHandler(JOrbitLabOutline applet){
      this.applet=applet;
   }

   public void actionPerformed(ActionEvent e){
      applet.simulationStep();
   }
}

class StepBackHandler implements ActionListener {
   JOrbitLabOutline applet;

   public StepBackHandler(JOrbitLabOutline applet){
      this.applet=applet;
   }

   public void actionPerformed(ActionEvent e){
      applet.odeAdaptiveSolver.setStepSize(-applet.dt);
      applet.simulationStep();
      applet.odeAdaptiveSolver.setStepSize(applet.dt);
   }
}

class Platno extends JPanel{
   BufferedImage image;
   JOrbitLabOutline applet;

   //konstruktor
   public Platno(BufferedImage image, JOrbitLabOutline applet){
      this.image=image;
      this.applet=applet;
   }

   public void paintComponent(Graphics g){
      Graphics2D g2=(Graphics2D)g;
      g2.drawImage(image,null,0,0);
      applet.kresliVrch(g2);
   }
}

class IntegerPoint {
   int i,j;

   public IntegerPoint(int i, int j){
      this.i=i;
      this.j=j;
   }

   public int getI(){
      return i;
   }

   public int getJ(){
      return j;
   }
}

class Point3D {
   double x,y,z;

   public Point3D(double x, double y, double z){
      this.x=x;
      this.y=y;
      this.z=z;
   }

   public double getX(){
      return x;
   }

   public double getY(){
      return y;
   }

   public double getZ(){
      return z;
   }
}

class ProjPoint {
   double phi,theta;

   public ProjPoint(double phi, double theta){
      this.phi=phi;
      this.theta=theta;
   }

   public double getPhi(){
      return phi;
   }

   public double getTheta(){
      return theta;
   }

}


class Outline {
   int n;//aktualny pocet bodov v obryse
   IntegerPoint[] points;

   public Outline(){
      this.n=0;
      this.points=new IntegerPoint[10000];
   }

   public void addPoint(IntegerPoint p){
      points[n]=p;
      n++;
   }

   public IntegerPoint getPoint(int i){
      if(i<n) return points[i];
      else return null;
   }
}


